"""
__author__ = '霍格沃兹测试开发学社'
__desc__ = '更多测试开发技术探讨，请访问：https://ceshiren.com/t/topic/15860'
"""
# 字符串操作方法

# 统计查找替换类操作方法
def counting_category():
    # 统计字符个数 len
    print(len("hello"))
    print(len("helloworld"))

    # 统计字符串出现的次数 count
    s = "hello world hello Python"
    print(s.count("o"))
    print(s.count("llo"))
    print(s.count("llo", 10, 50))
    print(s.count('O'))

    # 字符串查找方法 index
    s = "hello world hello Python"
    print(s.index("or"))
    print(s.index("l"))
    print(s.index("ll", 10))
    # print(s.index("python"))

    # 字符串查找方法 rindex
    s = "hello world hello Python"
    print(s.rindex("ll"))
    print(s.rindex("ll",0,10))
    # print(s.rindex("lll"))

    # 字符串查找方法 find
    s = "hello world hello Python"
    print(s.find("ll"))
    print(s.find("ll", 10))
    print(s.find("lll"))

    # 字符串查找方法 rfind
    s = "hello world hello Python"
    print(s.rfind("ll"))
    print(s.rfind("ll", 0, 10))
    print(s.rfind("lll"))

    # 字符串替换方法 replace
    s = "hello world hello Python"
    print(s.replace("o", "O"))
    print(s)
    print(s.replace("l","L", 4))

# 字符串判断类方法
def judgment_category():
    # 判断字符串是否以指定字符串开头 startswith
    url = "https://www.ceshiren.com"
    print(url.startswith("http://"))
    print(url.startswith("https://"))
    print(url.startswith("https://", 1))

    # 判断字符串是否以指定字符串结束 endswith
    url = "https://www.ceshiren.com"
    print(url.endswith(".com"))
    print(url.endswith(".com",0, 10))
    print(url.endswith(".cn"))
    print(url.endswith(".edu"))
    print(url.endswith(".org"))
    print(url.endswith(".gov"))

    # 判断字符串是否是全字母 isalpha()
    print("*" * 10)
    print("abc".isalpha())
    print("ABC".isalpha())
    print("ABCabc".isalpha())
    print("abcABC".isalpha())
    print("a1".isalpha())
    print("A1".isalpha())
    print("1a".isalpha())
    print("1A".isalpha())
    print("123".isalpha())
    print("@#".isalpha())
    print("".isalpha())

    # 判断是否是纯数字字符串 isdigit
    print("&" * 10)
    print('123'.isdigit())
    print("a123".isdigit())
    print("123a".isdigit())
    print("abc".isdigit())
    print("123!".isdigit())
    print("".isdigit())

    # 判断字符串是否是字母或数字组成 isalnum
    print("*" * 10)
    print("123".isalnum())
    print("abc".isalnum())
    print("ABC".isalnum())
    print("123abc".isalnum())
    print("abc123".isalnum())
    print("1a@".isalnum())
    print("1 a".isalnum())
    print("".isalnum())

    # 判断字符串是否是空白符号组成的字符串 isspace
    print("^" * 10)
    print(" ".isspace())
    print("  ".isspace())
    print("     ".isspace())
    print("\t".isspace())
    print("\n".isspace())
    print("\r".isspace())
    print("1a ".isspace())
    print(" 1".isspace())
    print("".isspace())

    # 判断字符串是否全是大写字母 isupper
    print("*" * 10)
    print("ABC".isupper())
    print("ABC ".isupper())
    print("abc".isupper())
    print("ABC#".isupper())
    print("#ABC".isupper())
    print("ABC!".isupper())
    print("ABC1".isupper())
    print("ABCa".isupper())
    print("".isupper())

    # 判断是否为小写字符 islower
    print("*" * 10)
    print("abc".islower())
    print("abc1".islower())
    print("abc@".islower())
    print("@abc".islower())
    print("abcA".islower())
    print("".islower())

    # 判断字符串中所有的单词是否是标题化的 istitle（单词首字符串写）
    print("*" * 10)
    print("User Name".istitle())
    print("Username".istitle())
    print("User_Name".istitle())

    print("user name".istitle())
    print("user_name".istitle())
    print("UserNAME".istitle())
    print("user_Name".istitle())
    print("user Name".istitle())
    print("User name".istitle())
    print("Abc Def Gkk".istitle())

 # 字符串转换类方法

# 字符串转换方法
def transform_category():
     # 将字符串的第一个首字符大写 capitalize
     print("username".capitalize())
     print("UserName".capitalize())
     print("USERNAME".capitalize())
     print("this is nice day".capitalize())

     # 将字符串标题化 title
     print("*"* 10)
     print("username".title())
     print("user name".title())
     print("USER NAME".title())
     print("this is nice day".title())
     print("this is nICE day".title())
     print("USER_NAME".title())

     # 将字符串中的字母转换为大写 upper
     print('*' * 10)
     print("abc".upper())
     print("ABC".upper())
     print("abcABC".upper())
     print("abc123".upper())
     print("ABC123".upper())
     print("abcABC123@#$".upper())

     # 将字符串中的字母转换成小写 lower
     print("*" * 10)
     print("abc".lower())
     print("ABC".lower())
     print("ABCaabc".lower())
     print("ABC@#$".lower())
     print("@#$abc".lower())
     print("ABC234@#$abc".lower())
     print("123@#$".lower())

# 字符串对齐方法
def align_category():
    # 字符串在指定宽度内居中显示
    s = "hello"
    print("|" + s.center(20) + "|")
    print("|" + s.center(3) + "|")
    print("|" + s.center(20, "-") + "|")
    print("|" + s.center(20, "+") + "|")

    # 左对齐 ljust
    s = "hello"
    print("|" + s.ljust(20) + "|")
    print("|" + s.ljust(3) + "|")
    print("|" + s.ljust(20, "-") + "|")
    print("|" + s.ljust(20, "+") + "|")

    # 右对齐 rjust
    s = "hello"
    print("|" + s.rjust(20) + "|")
    print("|" + s.rjust(3) + "|")
    print("|" + s.rjust(20, "-") + "|")
    print("|" + s.rjust(20, "+") + "|")

# 去除空白类方法
def wipe_off_space_category():
    # 去除两侧空白 strip
    print("|" + "     hogwarts    ".strip() + "|")
    print("|" + "     hogwarts".strip() + "|")
    print("|" + "hogwarts    ".strip() + "|")
    print("|" + "     h  og w  a rt s    ".strip() + "|")

    # 去除左侧空白 lstrip
    print("|" + "     hogwarts    ".lstrip() + "|")
    print("|" + "     hogwarts".lstrip() + "|")
    print("|" + "hogwarts    ".lstrip() + "|")
    print("|" + "     h  og w  a rt s    ".lstrip() + "|")

    # 去除右侧空白 rstrip
    print("|" + "     hogwarts    ".rstrip() + "|")
    print("|" + "     hogwarts".rstrip() + "|")
    print("|" + "hogwarts    ".rstrip() + "|")
    print("|" + "     h  og w  a rt s    ".rstrip() + "|")

    print("aabaaABCaasabaab".strip("ab"))


# 字符串分割类
def partition_category():
    # 字符串分割方法 split
    s = "a-b-c-d"
    print(s.split("-"))
    print("a--b-c-d".split("-"))
    print("a--b-c-d".split("--"))
    print("a-b-c-d".split("--",2))
    print("a-b-c-d".split("-",2))
    print("a b  c   d\ne\tf\rg".split())

    # 使用\n换行符进行分割字符串 splitlines
    print("a\nb\nc".splitlines())
    print("a\nb\nc".splitlines(True))

    # 字符串分割，只分三段 partition
    print("8"* 10)
    print("http://www.hogwarts.com".partition("www"))
    print("http://www.hogwarts.com".partition("wwww"))
    print("http://www.hogwarts.com".partition("t"))

    # 从右侧字符串分割，只分三段 partition
    print("8" * 10)
    print("http://www.hogwarts.com".rpartition("www"))
    print("http://www.hogwarts.com".rpartition("wwww"))
    print("http://www.hogwarts.com".rpartition("t"))


# 字符串拼接方法
def connect_category():
    # 使用 + 拼接两个字符串
    s1 = "Hello"
    s2 = "Python"
    s3 = s1 + s2
    print(s1)
    print(s2)
    print(s3)

    # 使用 * 拼接字符串N次
    print(s1 * 10)

    # 使用 join 方法连接容器中的字符串元素
    print("".join("hello"))
    print("-".join("hello"))
    print("-->".join(("A","B","C")))
    print("-->".join(["A","B","C"]))
    print("-->".join({"A","B","C"}))
    print("-->".join({"A": "aa", "B": "bb" ,"C": "cc"}))

# 字符串编码方法
def coding_category():
    # 字符串编码方法 encode() 将字符串转换成二进制字符串
    print("A".encode("gbk"))
    print("A".encode("utf-8"))
    print("你好".encode("GBK"))
    print("你好".encode("u8"))

    # 字符串解码过程 decode 将二进制字符串转换字符串

    s3 = b'\xc4\xe3\xba\xc3'
    s4 = b'\xe4\xbd\xa0\xe5\xa5\xbd'
    print(s3.decode("GBK"))
    print(s4.decode("u8"))


    """
    你         好
    c4 e3     ba c3
    0-9ABCDEF
    11001110 11100011       10111010 11000011
    """


# 字符串切片
# 切片操作是有一个公共操作，并不是字符串独有的，可迭代的对象都可以进行切片操作。
def section_category():
    s="0123456789"
    print(s[0:5])
    print(s[3:8])
    print(s[0:])
    print(s[5:])
    print(s[:5])
    print(s[::2])
    print(s[::3])
    print(s[::-1])


if __name__ == '__main__':
    # counting_category()
    # judgment_category()
    # transform_category()
    # align_category()
    # wipe_off_space_category()
    # partition_category()
    # connect_category()
    # coding_category()
    section_category()