"""
__author__ = '霍格沃兹测试开发学社'
__desc__ = '更多测试开发技术探讨，请访问：https://ceshiren.com/t/topic/15860'
"""
# 函数引用

# def show():
#     m = 100
#     print("Show Run ...", m)
#
#
# show()
# display = show
# display()


# 闭包的定义
# 外函数
# def out_func():
#     m = 100
#     # 内函数
#     def in_func():
#         print("这是内函数的输出，引用了外函数的变量m, 值为:", m)
#     # 外函数一定要返回内函数的引用
#     return in_func

# 使用闭包
#
# func1 = out_func()
# func2 = out_func()
# print("Hello")
# func1()
# func2()
# print(func1)
# print(func2)

# def out_func():
#     out_n = 100
#     def inner_func():
#         nonlocal out_n
#         out_n = 200
#         print("inner:",out_n)
#     print("outer1:",out_n)
#     inner_func()
#     print("outer2:",out_n)
#     return inner_func
#
#
# if __name__ == '__main__':
#     of1 = out_func()
#     of1()

# import time
#
# # 定义一个闭包，用来统计一个函数的执行时间
# def count_time(func):
#     def inner(*args, **kwargs):
#         start = time.time()
#         result = func(*args, **kwargs)
#         stop = time.time()
#         print(f"函数共运行了 {stop - start} 秒")
#         return result
#     return inner
#
#
# @count_time
# def show():
#     s = 0
#     for i in range(100001):
#         s += i
#     print(s)
#
# @count_time
# def display(n, msg):
#     for i in range(n):
#         print(msg)
#
# @count_time
# def get_msg():
#     return "Hogwarts"
#
# # show = count_time(show)
#
# show()
# display(5, "Hello")
#
# display = count_time(display)
#
# print(get_msg())

#
# def decorator_args(vars, datas):
#     def decorator(func):
#         print(vars)
#         print(datas)
#         def inner(*args, **kwargs):
#             return func(*args, **kwargs)
#         return inner
#     return decorator
#
# data = [(1,2,3),(4,5,6),(7,8,9)]
# # 装饰器传参
# @decorator_args("a,b,c", data)
# def show(a,b,c):
#     print(a,b,c)
'''
@decorator_args("a,b,c", data)

decorator_args("a,b,c", data) -> decorator

@decorator

@decorator
def show():

show = decorator(show)

show = inner

show() -> inner()


'''

# 接收装饰器参数的函数
# 参数一：以字符串形式接收被装饰函数的参数列表，需要与被装饰函数参数名保持一致，例："a,b,c"
# 参数二：以[(),(),()] 形式传入驱动数据。
def decorator_args(vars, datas):
    def decorator(func):
        # 将字符串参数分割备用
        v_keys = vars.split(",")
        # 定义保存 [{},{},{}] 形式的数据
        new_datas = []
        # 遍历数据，取出一组元素数据
        for item in datas:
            # 定义一个新字典，用来保存 变量名与传入数据组成的字典
            d_item = {} # {"a": 1, "b": 2, "c": 3}
            # 使用 zip 函数，同时遍历两个元组，变量名做为key, 元素数据做为value
            # [a,b,c]
            # （1，2，3）
            for k, v in zip(v_keys, item):
                # 将 变量名和值对应保存到字典中
                d_item[k] = v
            # 将组合好的字典追加到新数据中备用
            new_datas.append(d_item)
        def inner(*args, **kwargs):
            return func(*args, **kwargs)
        # 遍历新数据，取出元素字典
        for item in new_datas:
            # 将字典中的数据解包传给内函数
            inner(**item)
        return inner
    return decorator

# 数据驱动数据
data = [(1,2,3),(4,5,6),(7,8,9),('hello', "World", "python")]

# 装饰器传参
@decorator_args("a,b,c", data)
def show(a,b,c):
    print(a,b,c)


