"""
__author__ = '霍格沃兹测试开发学社'
__desc__ = '更多测试开发技术探讨，请访问：https://ceshiren.com/t/topic/15860'
"""
# class A:
#     def show(self):
#         print("A show")
#
# class B(A):
#     def show(self):
#         print("B show")
#
#
# def call_func(obj):
#     obj.show()
#
#
# a = A()
# b = B()
# call_func(a)
# call_func(b)


# 中医
class Father:
    def cure(self):
        print("使用中医方法进行治疗。。。")

# 西医
class Son(Father):
    def cure(self):
        print("使用西医方法进行治疗。。。")

# 兽医
class AnimalDoctor:
    def cure(self):
        print("使用兽医方法进行治疗。。。")


class Teacher:
    def tech(self):
        print("特级优秀数学老师")

    def cure(self):
        print("使用自己生病的经验来进行治疗。。。")

# 患者
class Patient:
    def needDoctor(self, doctor):
        # if isinstance(doctor, Father):
        #     doctor.cure()
        # else:
        #     print("此大夫医疗方法不适用病人。。。")

        if issubclass(doctor.__class__, Father):
            doctor.cure()
        else:
            print("此大夫医疗方法不适用病人。。。")


if __name__ == '__main__':
    oldDoctor = Father()
    littleDoctor = Son()
    ad = AnimalDoctor()

    t = Teacher()

    patient = Patient()

    patient.needDoctor(oldDoctor)
    patient.needDoctor(littleDoctor)
    patient.needDoctor(ad)
    patient.needDoctor(t)

    print(isinstance(littleDoctor, Father))
    print(isinstance(littleDoctor, Son))
    print(isinstance(littleDoctor, AnimalDoctor))
    print(isinstance(littleDoctor, Teacher))

    print("*"* 20)
    print(issubclass(Father, Father))
    print(issubclass(Son, Father))
    print(issubclass(AnimalDoctor, Father))
    print(issubclass(Teacher, Father))

    print(oldDoctor.__class__)
    print(littleDoctor.__class__)
    print(ad.__class__)
    print(t.__class__)



