"""
__author__ = '霍格沃兹测试开发学社'
__desc__ = '更多测试开发技术探讨，请访问：https://ceshiren.com/t/topic/15860'
"""

# 格式化字符串
def format_string():
    # format方法
    msg = "My Name is {} Age: {}".format("Tom",22)
    print(msg)
    msg = "My Name is {} Age: {}".format("Jack",23)
    print(msg)

    # 位置参数格式化字符串
    msg = "My Name is {0} Age: {1}".format("Jack", 23)
    print(msg)
    msg = "My Age is {1} Name: {0}".format("Jack", 23)
    print(msg)
    msg = "My Age is {1} Name: {0}---My Age is {1} Name: {0}--My Age is {1} Name: {0}".format("Jack", 23)
    print(msg)

    # 关键字参数
    msg = "My Name is {name} Age: {age}".format(name="Jack", age=23)
    print(msg)
    username = "Alice"
    msg = "My Name is {name} Age: {age}".format(name=username, age=23)
    print(msg)
    msg = "My Name is {name} Age: {age}My Name is {name} Age: {age}My Name is {name} Age: {age}".format(name=username, age=23)
    print(msg)

    # 格式化字符串时，指定格式化选项
    pi = 3.141592653589793
    formatted_pi = "The value of pi is approximately {:.2f}".format(pi)
    print(formatted_pi)

    # 字符串对齐
    print("The value is ljust: |{:5}|".format("abc"))
    print("The value is ljust: |{:<5}|".format("abc"))
    print("The value is rjust: |{:>5}|".format("abc"))
    # 数字对齐
    print("The value is rjust: |{:5}|".format(11))
    print("The value is rjust: |{:>5}|".format(11))
    print("The value is ljust: |{:<5}|".format(11))

    # f-string
    name = "Tony"
    age = 234234
    msg = f"My Name is {name} Age: {age}"
    print(msg)

    # 字符串对齐
    print(f"The value is ljust: |{'abc':5}|")
    print(f"The value is ljust: |{'abc':<5}|")
    print(f"The value is rjust: |{'abc':>5}|")
    # 数字对齐
    print(f"The value is rjust: |{11:5}|")
    print(f"The value is ljust: |{11:<5}|")
    print(f"The value is rjust: |{11:>5}|")
    # 小数保留
    print(f"The value is rjust: |{3.1415926:5.2f}|")

    name = "Alice"
    age = 45
    greeting = f"{'Hello' if age < 30 else 'Hi'} {name.upper()}"
    print(greeting)

    msg = "Name: %s Age: %d" % ("tom", 25)
    print(msg)

    sid = 5
    name = "Tom"
    sql_string = f""" select * from user where id > {sid} name={name} """
    print(sql_string)


format_string()