"""
__author__ = '霍格沃兹测试开发学社'
__desc__ = '更多测试开发技术探讨，请访问：https://ceshiren.com/t/topic/15860'
"""
# 简单的元组推导式
# t1 = (x for x in range(1,11))
#
# # 生成128位ASCII码元组
# t2 = ((chr(x),x) for x in range(128))
#
# # 生成100以内能被7整除所有数字的元组
# t3 = (x for x in range(100) if x%7==0)
#
# # 生成99乘法表结果元组
# t4 = (x*y for x in range(1,10) for y in range(1, x+1))
#
# words = ["apple", "banana", "cherry"]
# upper_words = (word.upper() for word in words)


# 简单的元组推导式
l1 = [x for x in range(1, 10)]
# l1 = []
# for x in range(1, 10):
#     l1.append(x)

# 生成128位ASCII码元组
# l2 = [chr(x) for x in range(128)]
# l2 = []
# for x in range(129):
#     x = chr(x)
#     l2.append(x)

# 生成100以内能被7整除所有数字的元组
l3 = [x for x in range(100) if x%7==0]
# l3 = []
# for x in range(100):
#     if x % 7 == 0:
#         l3.append(x)


# 生成99乘法表结果元组
l4 = [x*y for x in range(1,10) for y in range(1, x+1)]
# l4 = []
# for x in range(1, 10):
#     for y in range(1, x + 1):
#         l4.append(x*y)

# 将列表中的字符串转换为大写
words = ["apple", "banana", "cherry"]
upper_words = [word.upper() for word in words]

upper_words = []
print(upper_words)
for i in words:
    upper_words.append(i.upper())


names = ['Bob','Tom','alice','Jerry','Wendy','Smith']
# 将列表中各字符串值为键，各字符串的长度为值，组成键值对
newdict = {name:len(name) for name in names}
# for k,v  in newdict.items():
#     print(k,v)

data = ['Bob','123','Tom','ab123','alice','123abc','Jerry','456','Wendy','554','Smith']
# 筛选列表中的数字字符串
newset = {n for n in data if n.isdigit()}
for x in newset:
    print(x)